# mypy-boto3-cognito-idp

[![PyPI - mypy-boto3-cognito-idp](https://img.shields.io/pypi/v/mypy-boto3-cognito-idp.svg?color=blue)](https://pypi.org/project/mypy-boto3-cognito-idp)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-cognito-idp.svg?color=blue)](https://pypi.org/project/mypy-boto3-cognito-idp)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-cognito-idp](#mypy-boto3-cognito-idp)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)

Type annotations for
[boto3.CognitoIdentityProvider 1.14.0](https://boto3.amazonaws.com/v1/documentation/api/1.14.0/reference/services/cognito-idp.html#CognitoIdentityProvider) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.4](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `CognitoIdentityProvider` service.

```bash
python -m pip install boto3-stubs[cognito-idp]
```

Use `boto3` with `mypy_boto3_cognito_idp` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_cognito_idp import CognitoIdentityProviderClient

# Now mypy can check if your code is valid.
client: CognitoIdentityProviderClient = boto3.client("cognito-idp")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: CognitoIdentityProviderClient = session.client("cognito-idp")



# Annotated paginators are included as well

import mypy_boto3_cognito_idp.paginator as cognito_idp_paginators

admin_list_groups_for_user_paginator: cognito_idp_paginators.AdminListGroupsForUserPaginator = client.get_paginator("admin_list_groups_for_user")
admin_list_user_auth_events_paginator: cognito_idp_paginators.AdminListUserAuthEventsPaginator = client.get_paginator("admin_list_user_auth_events")
list_groups_paginator: cognito_idp_paginators.ListGroupsPaginator = client.get_paginator("list_groups")
list_identity_providers_paginator: cognito_idp_paginators.ListIdentityProvidersPaginator = client.get_paginator("list_identity_providers")
list_resource_servers_paginator: cognito_idp_paginators.ListResourceServersPaginator = client.get_paginator("list_resource_servers")
list_user_pool_clients_paginator: cognito_idp_paginators.ListUserPoolClientsPaginator = client.get_paginator("list_user_pool_clients")
list_user_pools_paginator: cognito_idp_paginators.ListUserPoolsPaginator = client.get_paginator("list_user_pools")
list_users_paginator: cognito_idp_paginators.ListUsersPaginator = client.get_paginator("list_users")
list_users_in_group_paginator: cognito_idp_paginators.ListUsersInGroupPaginator = client.get_paginator("list_users_in_group")
```

## Dynamic type annotations

`mypy_boto3` command generates `boto3.client/resource` type annotations for
`mypy_boto3_cognito_idp` and other installed services.

```bash
# Run this command after you add or remove service packages
python -m mypy_boto3
```

Generated type annotations provide overloads for `boto3.client` and `boto3.resource`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully if you have many services installed
- `VSCode` does not currently support function overloads, use explicit type annotations

```python
import boto3

# Type is discovered correctly by mypy and PyCharm
# VSCode still needs explicit type annotations
client = boto3.client("cognito-idp")

session_client = boto3.Session().client("cognito-idp")
```